/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "ColorTableItem.h"

ColorTableItem::ColorTableItem(QTable * table, EditType et) : QTableItem(table, et) {}

ColorTableItem::ColorTableItem(QTable * table, EditType et, const QColor & c) : QTableItem(table, et) {
    this->color = c;
}

void ColorTableItem::paint(QPainter * p, const QColorGroup & cg, const QRect & cr, bool selected) {
    QColorGroup g(cg);
    
    g.setColor(QColorGroup::Base, this->color);
    g.setColor(QColorGroup::Highlight, this->color);
    
    QTableItem::paint(p, g, cr, selected);
}

void ColorTableItem::setColor(const QColor & c) {
    this->color = c;
}

const QColor & ColorTableItem::getColor() const {
    return this->color;
}
