/***************************************************************************
 *                                                             *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef COLORTABLEITEM_H
#define COLORTABLEITEM_H

#include <qtable.h>


/// QTableItem que es pinta del color que guarda.

class ColorTableItem : public QTableItem
{
private:
    QColor color;
    
public:
    ColorTableItem(QTable * table, EditType et);
    ColorTableItem(QTable * table, EditType et, const QColor & c);
    
    virtual void paint(QPainter * p, const QColorGroup & cg, const QRect & cr, bool selected);
    
    void setColor(const QColor & c);
    const QColor & getColor() const;
};

#endif
