#ifndef UDGCHOOSESEEDWIDGET_H
#define UDGCHOOSESEEDWIDGET_H

#include "chooseseedwidgetbase.h"
#include "qseedsliceviewer.h"
#include "qlistview.h"

namespace udg {

class Volume;

/**
    Aquest widget visualitza les tres vistes d'un volum ( Axial, Coronal, Sagital ).
    Aquesta s la nova versi que fa servir el qsimplesliceview. Aquestes 3 vistes 
    permetran a l'usuari seleccionar les llavors dels mtodes de segmentaci
    
    @author Grups de Grfics Girona (GGG)
*/
class ChooseSeedWidget : public ChooseSeedWidgetBase
{
Q_OBJECT
public:
    ChooseSeedWidget(QWidget *parent = 0, const char *name = 0);

    ~ChooseSeedWidget(); 

    /**
        Assigna el volum a visualitzar
    */
    void setInputImage(Volume* newImageData);
    
    QListView* getSeedList();

signals:

    ///Signal que s'emetra quan l'usuari premi el boto "Ok"
    void signalOk();

public slots:

    virtual void slotAddSeed(int view,double x,double y,double z,double v);
    virtual void slotDelete();    
    virtual void slotDeleteRange(QListViewItem* item);
    virtual void slotOk();
    virtual void slotClose();
    virtual void slotSelectItem();

private:
    ///Guarda l'anterior llavor seleccionada
    int m_nAnt;

};

};

#endif
