/***************************************************************************
 *   Copyright (C) 2005 by Grup de Grfics de Girona                       *
 *   http://iiia.udg.es/GGG/index.html?langu=uk                            *
 *                                                                         *
 *   Universitat de Girona                                                 *
 ***************************************************************************/

#ifndef UDGCONNECTEDTHRESHOLDPARAMETERS_H
#define UDGCONNECTEDTHRESHOLDPARAMETERS_H

#include "parameters.h"
#include "identifier.h"
#include "qlistview.h"

namespace udg {

/**
    Sub-classe de Parameters. En aquest cas encapsula els parmetres del mtode de segmentaci
    ConnectedThreshold.
    
    Tindrem un mtode set/get per tots i cadascun dels parmetres del mtode.
    Els mtodes set emetran el signal changed amb l'id de parmetre que hem creat amb el tipus
    enumerat
*/

class ConnectedThresholdParameters : public Parameters
{
Q_OBJECT
public:
    
    /**
        Aquest tipus enumerat ens serveix per crear els identificadors de cada parmetre.
    */
     enum ConnectedThresholdParametersNames { VolumeId, LowerThreshold, UpperThreshold, SeedList };

    ConnectedThresholdParameters(QObject *parent = 0, const char *name = 0);

    ~ConnectedThresholdParameters();

    
    void setVolumeId( udg::Identifier id)
    {   m_volumeId= id;	emit changed(VolumeId); }
    
    void setLowerThreshold(int lower)
    {  	m_lowerThreshold=lower;	emit changed(LowerThreshold); }
    
    void setUpperThreshold(int upper)
    {	m_upperThreshold=upper;	emit changed(UpperThreshold); }

    void setSeedList(QListView* l)
    {	m_seedList=l; emit changed(SeedList); }

    udg::Identifier getVolumeId() const
    { 	return m_volumeId;}
    
    int getLowerThreshold() const
    {  	return m_lowerThreshold; }
    
    int getUpperThreshold() const
    { 	return m_upperThreshold; }

    QListView* getSeedList() const
    {	return m_seedList; }


 private:

    //Identificador del volum de dades amb el que treballem
    udg::Identifier m_volumeId;
    
    //Parmetres del mtode
    int m_lowerThreshold, m_upperThreshold;
    QListView* m_seedList;
};

};

#endif
