# Fitxer generat pel gestor de qmake de kdevelop. 
# ------------------------------------------- 
# Subdirectori relatiu al directori principal del projecte: ./src/interface
# L'objectiu s una biblioteca:  

TEMPLATE = lib
CONFIG += debug \
warn_on \
qt \
opengl \
thread \
x11 \
staticlib \
exceptions \
stl
OBJECTS_DIR = ../../tmp/obj
UI_DIR = ../../tmp/ui
MOC_DIR = ../../tmp/moc
INCLUDEPATH = ../visualization \
../tools \
../inputoutput \
../segmentation \
../registration \
../repositories
LIBS += ../visualization/libvisualization.a \
../repositories/librepositories.a \
../inputoutput/libinputoutput.a \
../segmentation/libsegmentation.a \
../registration/libregistration.a \
../tools/libtools.a
TARGETDEPS += ../visualization/libvisualization.a \
../repositories/librepositories.a \
../registration/libregistration.a \
../segmentation/libsegmentation.a \
../tools/libtools.a \
../inputoutput/libinputoutput.a
include(../vtk.inc)
include(../itk.inc)
SOURCES += director.cpp \
           mutualinformationdirector.cpp \
           parameters.cpp \
           qaxisviewer.cpp \
           qworkingarea.cpp \
           qmaintoolbox.cpp \
           qapplicationmainwindow.cpp \
           qwidgetvolume.cpp \
           qworkingareawindow.cpp \
           qworkingareawidget.cpp \
           qsimplesliceviewer.cpp \
           qmaintoolboxpage.cpp \
           qinputparameters.cpp \
           mutualinformationinputparametersform.cpp \
           mutualinformationparameters.cpp \
           QVTKWidget.cxx \
           vtkEventQtSlotConnect.cxx \
           qsimple3dviewer.cpp \
           connectedthresholddirector.cpp \
           connectedthresholdparameters.cpp \
           chooseseedwidget.cpp \
           qseedsliceviewer.cpp \
           volumecalculator.cpp \
           connectedthresholdinputparametersform.cpp \
           viewresultswidget.cpp \
           neighborhoodconnectedparameters.cpp \
           neighborhoodconnecteddirector.cpp \
           neighborhoodconnectedinputparametersform.cpp \
           confidenceconnecteddirector.cpp \
           confidenceconnectedparameters.cpp \
           isolatedconnecteddirector.cpp \
           isolatedconnectedparameters.cpp \
           confidenceconnectedinputparametersform.cpp \
           isolatedconnectedinputparametersform.cpp \
           fastmarchingdirector.cpp \
           fastmarchingparameters.cpp \
           fastmarchinginputparametersform.cpp \
           shapedetectiondirector.cpp \
           shapedetectionparameters.cpp \
           shapedetectioninputparametersform.cpp \
           geodesicactiveinputparametersform.cpp \
           geodesicactivedirector.cpp \
           geodesicactiveparameters.cpp \
           raycastingparameters.cpp \
           raycastinginputparametersform.cpp \
           raycastingdirector.cpp \
           qwcolorbutton.cpp \
           ColorTableItem.cpp \
           viewresultsraycastingwidget.cpp \
           multiplaneinputparametersform.cpp \
           multiplanedirector.cpp 
HEADERS += director.h \
           mutualinformationdirector.h \
           parameters.h \
           qaxisviewer.h \
           qworkingarea.h \
           qmaintoolbox.h \
           qapplicationmainwindow.h \
           qwidgetvolume.h \
           qworkingareawindow.h \
           qworkingareawidget.h \
           qsimplesliceviewer.h \
           qmaintoolboxpage.h \
           qinputparameters.h \
           mutualinformationinputparametersform.h \
           mutualinformationparameters.h \
           QVTKWidget.h \
           vtkEventQtSlotConnect.h \
           qsimple3dviewer.h \
           connectedthresholddirector.h \
           connectedthresholdparameters.h \
           chooseseedwidget.h \
           qseedsliceviewer.h \
           volumecalculator.h \
           connectedthresholdinputparametersform.h \
           viewresultswidget.h \
           neighborhoodconnectedparameters.h \
           neighborhoodconnecteddirector.h \
           neighborhoodconnectedinputparametersform.h \
           confidenceconnecteddirector.h \
           confidenceconnectedparameters.h \
           isolatedconnecteddirector.h \
           isolatedconnectedparameters.h \
           confidenceconnectedinputparametersform.h \
           isolatedconnectedinputparametersform.h \
           fastmarchingdirector.h \
           fastmarchingparameters.h \
           fastmarchinginputparametersform.h \
           shapedetectiondirector.h \
           shapedetectionparameters.h \
           shapedetectioninputparametersform.h \
           geodesicactiveinputparametersform.h \
           geodesicactivedirector.h \
           geodesicactiveparameters.h \
           raycastingparameters.h \
           raycastinginputparametersform.h \
           qwcolorbutton.h \
           raycastingdirector.h \
           ColorTableItem.h \
           viewresultsraycastingwidget.h \
           multiplaneinputparametersform.h \
           multiplanedirector.h 
FORMS += qaxisviewerbase.ui \
         mutualinformationinputparametersformbase.ui \
         chooseseedwidgetbase.ui \
         helpconnectedthresholdwidget.ui \
         viewresultswidgetbase.ui \
         helpneighborhoodconnectedwidget.ui \
         helpconfidenceconnectedwidget.ui \
         helpisolatedconnectedwidget.ui \
         helpfastmarchingwidget.ui \
         helpshapedetectionwidget.ui \
         helpgeodesicactivewidget.ui \
         helpraycastingwidget.ui \
         raycastinginputparametersformbase.ui \
         viewresultsraycastingwidgetbase.ui \
         confidenceconnectedinputparametersformbase.ui \
         connectedthresholdinputparametersformbase.ui \
         fastmarchinginputparametersformbase.ui \
         geodesicactiveinputparametersformbase.ui \
         isolatedconnectedinputparametersformbase.ui \
         neighborhoodconnectedinputparametersformbase.ui \
         qmaintoolboxpagebase.ui \
         shapedetectioninputparametersformbase.ui \
         multiplaneinputparametersformbase.ui 
