/***************************************************************************
 *   Copyright (C) 2005 by Grup de Grfics de Girona                       *
 *   http://iiia.udg.es/GGG/index.html?langu=uk                            *
 *                                                                         *
 *   Universitat de Girona                                                 *
 ***************************************************************************/

#ifndef UDGISOLATEDCONNECTEDPARAMETERS_H
#define UDGISOLATEDCONNECTEDPARAMETERS_H

#include "parameters.h"
#include "identifier.h"
#include "qlistview.h"

namespace udg {

/**
    Sub-classe de Parameters. En aquest cas encapsula els parmetres del mtode de segmentaci
    IsolatedConnected.
    
    Tindrem un mtode set/get per tots i cadascun dels parmetres del mtode.
    Els mtodes set emetran el signal changed amb l'id de parmetre que hem creat amb el tipus
    enumerat
*/

class IsolatedConnectedParameters : public Parameters
{
Q_OBJECT
public:
    
    /**
        Aquest tipus enumerat ens serveix per crear els identificadors de cada parmetre.
    */
     enum IsolatedConnectedParametersNames { VolumeId, LowerThreshold, InsideSeedList, OutsideSeedList };

    IsolatedConnectedParameters(QObject *parent = 0, const char *name = 0);

    ~IsolatedConnectedParameters();

    
    void setVolumeId( udg::Identifier id)
    {   m_volumeId= id;	emit changed(VolumeId); }
    
    void setLowerThreshold(int lower)
    {  	m_lowerThreshold=lower;	emit changed(LowerThreshold); }

    void setInsideSeedList(QListView* l)
    {	m_insideSeedList=l; emit changed(InsideSeedList); }

    void setOutsideSeedList(QListView* l)
    {	m_outsideSeedList=l; emit changed(OutsideSeedList); }

    udg::Identifier getVolumeId() const
    { 	return m_volumeId;}
    
    int getLowerThreshold() const
    {  	return m_lowerThreshold; }    
    
    QListView* getInsideSeedList() const
    {	return m_insideSeedList; }

    QListView* getOutsideSeedList() const
    {	return m_outsideSeedList; }

 private:

    //Identificador del volum de dades amb el que treballem
    udg::Identifier m_volumeId;
    
    //Parmetres del mtode
    int m_lowerThreshold;
    QListView* m_insideSeedList;
    QListView* m_outsideSeedList;
};

};

#endif
