#ifndef UDGMULTIPLANEDIRECTOR_H
#define UDGMULTIPLANEDIRECTOR_H

#include "director.h"
#include "volume.h"


namespace udg {


/**
    Sub-classe de Director. En aquest cas fa de pont amb un mtode de visualitzaci anomenat
    Multiplane.
*/


class MultiplaneDirector : public Director
{
Q_OBJECT
public:

    typedef udg::Volume::ItkImageType ImageType;
    

    MultiplaneDirector(udg::QApplicationMainWindow* app, QObject *parent = 0, const char *name = 0);
    ~MultiplaneDirector();

    /// Li indiquem el volum a visualitzar
    void setVolume( Volume* inputImage );

public slots:
    /**
        Aquest mtode aplica el mtode de visualitzaci. Comprova primer si t els parmetres
        necessaris, sin retornar fals. Slot pblic heredat de Director.
    */
    void execute();    
 
private:

    udg::QApplicationMainWindow* m_applicationWindow;
    Volume* m_volume;
};

};

#endif
