/***************************************************************************
 *   Copyright (C) 2005 by Grup de Grfics de Girona                       *
 *   http://iiia.udg.es/GGG/index.html?langu=uk                            *
 *                                                                         *
 *   Universitat de Girona                                                 *
 ***************************************************************************/

 
#ifndef PARAMETERS_H
#define PARAMETERS_H

#include <qobject.h>

/**
    Classe base Parameters. Aquesta classe s'encarrega d'encapsular els parmetres d'un mtode
    en concret. Aquesta proporciona la interfcie comuna per a totes les que heredin d'aquesta.
    
    Proporciona un signal changed(int) el qual indicar quin parmetre s'ha actualitzat. El parmetre 
    d'aquest signal ser un ndex que identifica quin parmetre ha canviat. Les sub-classes tindran
    un tipus enumerat que far d'ndex per cada parmetre
*/

namespace udg{

class Parameters : public QObject{
Q_OBJECT
public:
    Parameters(QObject *parent = 0, const char *name = 0);

    virtual ~Parameters();

signals:
    /// indica a les interfcies que un dels seus parmetres s'ha actualitzat
    /// El parmetre s un enter que identifica el parmetre
    void changed( int ); 

};

}; // end namespace udg
#endif
// fi de #endif
