/***************************************************************************
 *   Copyright (C) 2005 by Grup de Grfics de Girona                       *
 *   http://iiia.udg.es/GGG/index.html?langu=uk                            *
 *                                                                         *
 *   Universitat de Girona                                                 *
 ***************************************************************************/

 
#include <qaxisviewer.h>
#include <qslider.h>
#include <qspinbox.h>

#include "volume.h"

namespace udg{ 

QAxisViewer::QAxisViewer(QWidget *parent, const char *name, WFlags fl)
 :QAxisViewerBase(parent, name, fl)
{
    if (!name)
        this->setName( "QAxisViewer" );
 }

QAxisViewer::~ QAxisViewer()
{
}

void QAxisViewer::setInputImage(Volume* newImageData)
{
    
    this->m_axialView->setVolume( newImageData );
    this->m_sagittalView->setVolume( newImageData );
    this->m_coronalView->setVolume( newImageData );
  
    this->m_axialView->setView( QSimpleSliceViewer::Axial );    
    this->m_sagittalView->setView( QSimpleSliceViewer::Sagittal );
    this->m_coronalView->setView( QSimpleSliceViewer::Coronal );
  
    int *size = newImageData->getVtkData()->GetDimensions();

    this->m_xAxisSlider->setMaxValue( size[2]-1 );
    this->m_yAxisSlider->setMaxValue( size[1]-1 );
    this->m_zAxisSlider->setMaxValue( size[0]-1 );
    
    this->m_xAxisSpinBox->setMaxValue( size[2]-1 );
    this->m_yAxisSpinBox->setMaxValue( size[1]-1 );
    this->m_zAxisSpinBox->setMaxValue( size[0]-1 );

    // Posem tots els sliders i valors spinboxs a z/2. Els sliders automaticament s'hi posaran
    // igual que les imatges tb. (gracies a la propagacio de signals-slots)
    this->m_xAxisSpinBox->setValue( size[2]/2 );
    this->m_yAxisSpinBox->setValue( size[1]/2 );
    this->m_zAxisSpinBox->setValue( size[0]/2);

} 

} // end namespace udg
