/***************************************************************************
 *   Copyright (C) 2005 by Grup de Grfics de Girona                       *
 *   http://iiia.udg.es/GGG/index.html?langu=uk                            *
 *                                                                         *
 *   Universitat de Girona                                                 *
 ***************************************************************************/
  
#ifndef UDGQMAINTOOLBOX_H
#define UDGQMAINTOOLBOX_H

#include <qwidget.h>

// forward declarations
class QToolBox;
class QAction;

#include <qstring.h>

#include "identifier.h"

#include "qmaintoolboxpage.h"

namespace udg {

class VolumeRepository;
class QAxisViewer;

/**
    Aquesta classe encapsula dins seu un toolbox. Aquest estar ajustat a les nostres necessitats
    i tindr una estructura que no espodr modificar directament. Acceptar la inclusi
    de nous formularis que hauran de complir uns certs requisits per poder-se afegir.
    
@author Grup de Grfics de Girona  ( GGG )
*/

class QMainToolBox : public QWidget{
    Q_OBJECT
public:
    QMainToolBox(QWidget *parent = 0, const char *name = 0);

    ~QMainToolBox();

    enum TabIndex{ AxisViewTab, RegistrationTab, SegmentationTab, VisualizationTab };

    /** 
        Afegeix un widget al toolbox dins de la pestanya que indiquem amb el nom que l'identifica    
        
        
        \param widget El formulari que anir al WidgetStack
        
        \param index Indica la pestanya on volem collocar el formulari
        Els valors vlids per a index sn QMainToolBox::RegistrationTab, 
        QMainToolBox::SegmentationTab o QMainToolBox::VisualizationTab
        
        \param name El nom que identifica el mtode i que apareixer al combo box per a seleccionar-lo
        
        \param trigger Acci que disparar el mtode a aplicar
    */
    void addWidget( QWidget* widget, TabIndex index, QString name , QAction* trigger );
    
        

public slots:
    /**
        Aquest slot s'encarrega d'actualitzar els widgets del toolbox que fan servir 
        algun volum, com per exemple l'axis viewer
    */
    void updateImageData(Identifier id);

private:
    QToolBox* m_toolBox;
    VolumeRepository* m_volumeRepository;
    QAxisViewer* m_axisViewer;

};

};  

#endif
