/***************************************************************************
 *   Copyright (C) 2005 by Grup de Grfics de Girona                       *
 *   http://iiia.udg.es/GGG/index.html?langu=uk                            *
 *                                                                         *
 *   Universitat de Girona                                                 *
 ***************************************************************************/

 
#include "qmaintoolboxpage.h"

#include "qinputparameters.h" // necessari per les pgines que afegim i recuperem
// necessaris per fer els connects
#include <qcombobox.h>
#include <qwidgetstack.h>
#include <qpushbutton.h>
#include <qaction.h>

// per debug only
#include <iostream.h>

#include "qcursor.h"

namespace udg {

QMainToolBoxPage::QMainToolBoxPage(QWidget *parent, const char *name)
 : QMainToolBoxPageBase(parent, name)
{
    // connectem el combo amb el widgetStack perqu canvin les pgines
    connect( this->m_comboMethod, SIGNAL( activated(int) ), this, SLOT( raisePage(int) ) );
    connect( m_applyButton , SIGNAL( clicked() ) , this, SLOT( applyMethod() ) );

    id=0;
}

void QMainToolBoxPage::raisePage( int index )
{
    m_widgetStack->raiseWidget( index );
}

QMainToolBoxPage::~QMainToolBoxPage()
{
} 

void
QMainToolBoxPage::addPage( QWidget* page, QString &methodName, QAction* trigger )
{

    std::cout<<"el metode inserit s "<<methodName<<std::endl;

    m_comboMethod->insertItem( methodName );
    // \TODO s necessari canviar-li le pare?
    //page->reparent( this->m_widgetStack );
    int w=m_widgetStack->addWidget( page,id );
    id=id+1;
    //cout << "Id " << methodName << ": " << id << endl;
    
    m_triggerList.append( trigger );
    //connect( m_comboMethod, SIGNAL( activated(int) ), m_widgetStack, SLOT( raiseWidget(int) ) );
}


void QMainToolBoxPage::applyMethod()
{
    //Posem el cursor en mode espera (indicant execuci)
    QCursor cursor(WaitCursor);
    setCursor(cursor);  

    int current;

    current = m_comboMethod->currentItem();

	std::cout << "current item s "<< current << std::endl;

    QInputParameters* widgetStackPage = static_cast< QInputParameters* >( m_widgetStack->widget( current ) );
    
    if( widgetStackPage )
    {
        //Comprovem que els parmetres siguin correctes (Biru)
        if(widgetStackPage->correctParameters())
        {
            // actualitzem els parmetres i cridem l'acci corresponent
            widgetStackPage->writeAllParameters();
            QAction* trigger = m_triggerList.at( current );
            trigger->activate();  
        }
    }
    else
    {
        std::cerr << " ERROR :: QMainToolBoxPage::applyMethod() >> widget retornat est buit... " << std::endl;
    }
    // fem la feina especfica quan rebem una petici d'aplicar/executar el mtode
    // \TODO ens peta aqu perqu no li retorna cap widget :_(  perqu? <-- s real?


    //Posem el cursor en mode normal
    QCursor cursor2(ArrowCursor);
    setCursor(cursor2);
}

QComboBox* QMainToolBoxPage::getCombo()
{

return m_comboMethod;
}

QWidgetStack* QMainToolBoxPage::getwidget()

{

return m_widgetStack;
}



/*
QMainToolBoxPage* item;
    
    item = dynamic_cast< QMainToolBoxPage* >( m_toolBox->item( index ) );
    if( item )
    {
        item->addPage( widget , name, trigger );   
    }

*/



};
