/***************************************************************************
 *   Copyright (C) 2005 by Grup de Grfics de Girona                       *
 *   http://iiia.udg.es/GGG/index.html?langu=uk                            *
 *                                                                         *
 *   Universitat de Girona                                                 *
 ***************************************************************************/

 
#ifndef UDGQMAINTOOLBOXPAGE_H
#define UDGQMAINTOOLBOXPAGE_H

#include "qmaintoolboxpagebase.h"

// forward declarations
class QComboBox;
class QWidgetStack;
class QPushButton;
class QAction;

#include <qstring.h>
#include <qptrlist.h>

namespace udg {
 
/**
    Pgina del QMainToolBox personalitzada. 

    @author Grup de Grfics de Girona  ( GGG )
*/

class QMainToolBoxPage : public QMainToolBoxPageBase{
Q_OBJECT
public:
    QMainToolBoxPage(QWidget *parent = 0, const char *name = 0);

    ~QMainToolBoxPage();

    /// Afegeix una pgina al Widget Stack intern
    void addPage( QWidget* page, QString &methodName, QAction* trigger );
    QWidgetStack* getwidget();
    QComboBox* getCombo();
    
public slots:
    /// Activa la QAction corresponent al mtode que s'hagi escollit
    void applyMethod();

    /// Fa aparixer la pgina de l'stack que es correspon amb el combo
    void raisePage( int index );
    
private:
    QPtrList<QAction> m_triggerList;

    //Biru
    int id; //Utilitzat per resoldre el problema del QToolBox
/*    
signals:
    void apply( int );
*/  

/* membres:
    m_comboMethod;
    m_widgetStack
    m_applyButton
    
    \TODO afegir un contador??? pe saber quants mtodes tenim? realment necessari?
*/  
};

};  

#endif
