/***************************************************************************
 *   Copyright (C) 2005 by Grup de Grfics de Girona                       *
 *   http://iiia.udg.es/GGG/index.html?langu=uk                            *
 *                                                                         *
 *   Universitat de Girona                                                 *
 ***************************************************************************/


#ifndef UDGQSIMPLESLICEVIEWER_H
#define UDGQSIMPLESLICEVIEWER_H

#include "qworkingareawidget.h"

namespace udg
{
    class Volume;
}
class QVBoxLayout;
class QVTKWidget;
class vtkImageViewer2;

namespace udg {
 
/**

    Visor simple de llesques. Fa servir la clase Volume com a input.
    Visualitza amb vtkImageViewer. Podem escollir la vista Axial, Coronal o Sagital
    Hereda de QWorkingAreaWidget, com tota finestra que va en l'rea de treball de
    l'aplicaci.
    
@author Grup de Grfics de Girona (GGG)
*/
class QSimpleSliceViewer : public QWorkingAreaWidget
{
Q_OBJECT
public:
    enum ViewType{ Axial, Coronal, Sagittal };
    QSimpleSliceViewer(QWidget *parent = 0, const char *name = 0);

    ~QSimpleSliceViewer();
    /// Li indiquem el volum a visualitzar
    void setVolume(Volume* inputVolume);
    /// Li indiquem la vista Axial, Coronal o Sagital
    void setView( ViewType view );

public slots:
  
    /// canvia la llesca que estem mirant
    void ChangeSlice(int value);
    // Aquests estan aqu per cpia de l'anterior classe que feia aix "QGLSliceView" per estan buits
    void IntensityMax(int value);
    void IntensityMin(int value);
    void ZoomIn();
    void ZoomOut();

signals:
    // Aquests signals estan aqu per cpia de l'anterior classe que feia aix "QGLSliceView"
    // de moment no s'han fet servir enlloc
    void Position(int, int, int, float);
    void SliceChanged(int);

private:
    
    QVBoxLayout* m_form1Layout;
    QVTKWidget* m_vtkWidget;
    Volume* m_volume; // s'hauria de fer cpia local!
    vtkImageViewer2* m_imageViewer;
//     vtkImageViewer2* m_imageViewer;
    ViewType m_lastView;
};

};

#endif
