/***************************************************************************
 *   Copyright (C) 2005 by Grup de Grfics de Girona                       *
 *   http://iiia.udg.es/GGG/index.html?langu=uk                            *
 *                                                                         *
 *   Universitat de Girona                                                 *
 ***************************************************************************/
 
#ifndef UDGQWIDGETVOLUME_H
#define UDGQWIDGETVOLUME_H

#include "qworkingareawidget.h"

class QVBoxLayout;
class QVTKWidget;
class QLabel;
class vtkRenderer;
class vtkEventQtSlotConnect;
class vtkObject;
class vtkImagePlaneWidget;


namespace udg{

class Volume;

/**
    Aquesta classe representa un widget que utilitza la classe QVTKWidget per mostrar un exemple de la seva integraci en l'interfcie. No hi afegeix res d'especial...
    Simplement que fa servir com a dades la clase Volume
    
    @author Grup de Grfics de Girona  ( GGG )
*/

class QWidgetVolume  : public QWorkingAreaWidget
{
Q_OBJECT
public:
    
    QWidgetVolume(QWidget *parent = 0, const char *name = 0);

    ~QWidgetVolume();
    
    /// Li indiquem el volum a visualitzar
    void setVolume( Volume* inputImage );

signals:
    void coordenatesChangedSignal(double, double, double);


protected slots:
    
    /// Posa les cadenes de texte als subwidgets utilitzant l'idioma actual
    virtual void languageChange();
    //void updateCoords(vtkObject*);
	void updateCoords();

private:
    bool isValidCursorStatus();
    
private:
    QVBoxLayout* m_form1Layout;
    QVTKWidget* m_vtkWidget;
    QLabel* m_textLabel2;
    vtkRenderer* m_ren;
    vtkEventQtSlotConnect* connections;
    vtkEventQtSlotConnect* m_connectionRelease;
    vtkImagePlaneWidget * xImagePlaneWidget;
    vtkImagePlaneWidget * yImagePlaneWidget;
    vtkImagePlaneWidget * zImagePlaneWidget;
    Volume* m_imageData;
};

}; // end namespace udg

#endif
