/***************************************************************************
 *   Copyright (C) 2005 by Grup de Grfics de Girona                       *
 *   http://iiia.udg.es/GGG/index.html?langu=uk                            *
 *                                                                         *
 *   Universitat de Girona                                                 *
 ***************************************************************************/

#ifndef QWORKINGAREA_H
#define QWORKINGAREA_H

#include <qworkspace.h>

namespace udg{

/**
    Defineix la "Working Area" de l'interfcie. Aqu ser on s'anir creant els diferents widgets per tal que l'usuari hi pugui interaccionar.
    
    @author Grup de Grfics de Girona  ( GGG )
*/

class QWorkingArea : public QWorkspace
{
    Q_OBJECT
public:
    enum ResizePolicyType { TILE, CASCADE };
    
    QWorkingArea(QWidget *parent = 0, const char *name = 0);
    ~QWorkingArea();

    ///Fixa la politica a seguir amb les finestres filles
    ///Poden ser del tipus ResizePolicyType
    void setResizePolicy( ResizePolicyType );
    
public slots:
    
    ///Actualitza el tamany de les finestres filles de manera que
    ///segueixin la politica marcada per ajustar-les.
    void resizeChilds();

protected:
    virtual void resizeEvent( QResizeEvent * );

private:
    ResizePolicyType m_policyType;
};

};
#endif
