#ifndef UDGRAYCASTINGINPUTPARAMETERSFORM_H
#define UDGRAYCASTINGINPUTPARAMETERSFORM_H

#include "raycastinginputparametersformbase.h"
#include "identifier.h"
#include "qtable.h"
#include "helpraycastingwidget.h"
#include "qlabel.h"
#include <qwcolorbutton.h>
#include <qcombobox.h>
#include <qradiobutton.h>

#include "ColorTableItem.h"


namespace udg {

//fordward declaration
class RayCastingParameters;
class VolumeRepository;

/**
@author Grup de Grfics de Girona  ( GGG )
*/
class RayCastingInputParametersForm : public RayCastingInputParametersFormBase
{
Q_OBJECT
public:
    RayCastingInputParametersForm(QWidget *parent = 0, const char *name = 0);

    ~RayCastingInputParametersForm();

    void setParameters( RayCastingParameters* parameters);

    ///Mtode per comprovar que els parmetres siguin correctes
    bool correctParameters();

public slots:
    /**
        Aquests sn els slots virtuals que heredem i que hem d'implementar
    */
    void readParameter(int index);    

    void writeAllParameters();

    ///Slot que s'executa quan premem el bot "Help"
    virtual void slotHelp();

    /**Slot que s'executa quan premem el bot "Add" per afegir una entrada a la funci
       de transfarncia.
    */
    virtual void slotAdd();

    ///Slot que s'executa per utilitzar la funci de transferncia manual.
    virtual void slotTransferFunction();

    ///Slot que s'executa per carregar la funci de transferncia per defecte.
    virtual void slotDefaultTransferFunction();

    void noOkScalar1();
    void noOkOpacity1();
    void noOkScalar2();
    void noOkOpacity2();

    virtual void slotDelete(int,int,int,const QPoint&);

    ///Slots utilitzats per la verificaci de parmetres
    virtual void slotChangeScalar1(const QString& text);
    virtual void slotChangeScalar2(const QString& text);
    virtual void slotChangeOpacity1(const QString& text);
    virtual void slotChangeOpacity2(const QString& text);
    //virtual void slotChangeDistance(const QString& text);

    

private:

   RayCastingParameters* m_parameters;
   Identifier m_volumeId;

   udg::VolumeRepository* m_volumeRepository;

   HelpRayCastingWidget* m_help;

   QString m_scalar1;
   QString m_opacity1;
   QString m_scalar2;
   QString m_opacity2;
   QString m_distance;

};

};

#endif
