#ifndef UDGVIEWRESULTSWIDGET_H
#define UDGVIEWRESULTSWIDGET_H

#include "viewresultswidgetbase.h"
#include "qsimplesliceviewer.h"
#include "qsimple3dviewer.h"
#include "viewresultsraycastingwidget.h"
#include "volumecalculator.h"
#include "qapplicationmainwindow.h"
#include "qwidgetvolume.h"

#include <qwcolorbutton.h>

#include "itkImage.h" 

namespace udg {

/**
@author Grup de Grfics de Girona  ( GGG )
*/
class ViewResultsWidget : public ViewResultsWidgetBase
{
Q_OBJECT
public:
    ViewResultsWidget(QWidget *parent = 0, const char *name = 0);
    ~ViewResultsWidget();
    
     /**
        Assigna el volum a visualitzar
    */
    void setInputImage(Volume* segmentedVolume,Volume* binaryVolume );
    void showView(); 

    typedef itk::Image<signed int,3>     ImageType; 

public slots:

    virtual void slotSliceArea(int i);
    virtual void slotChangeView(int i);
    virtual void slot3DView();
    virtual void slotMultiplane();
    


private:

    Volume* m_volume;
    Volume* m_binaryVolume;

    int m_numView; //0 s X, 1 s Y i 2 s Z
    float m_spacing[3];
    VolumeCalculator* m_xVolumeCalculator;
    VolumeCalculator* m_yVolumeCalculator;
    VolumeCalculator* m_zVolumeCalculator;
    
    //L'utilitzarem per poder dibuixar el 3D View a la working area
    udg::QApplicationMainWindow* m_applicationWindow;

};

};

#endif
