
#include "volumecalculator.h"
#include <iostream.h>

VolumeCalculator::VolumeCalculator(ImageType* rea, int proj){
	
	inputImage = rea;
	
	SliceIteratorType  inputIt(  inputImage,  inputImage->GetRequestedRegion() );
	
        switch(proj)
        {
            case 0: //X
                inputIt.SetFirstDirection(0);
                inputIt.SetSecondDirection(1);
            break;
            
            case 1://Y
                inputIt.SetFirstDirection(1);
                inputIt.SetSecondDirection(2);
            break;
        
            case 2: //Z
                inputIt.SetFirstDirection(0);
                inputIt.SetSecondDirection(2);
            break;
        }

	inputIt.GoToBegin();
	
        float totalVolume=0, sliceArea=0; //Guarden el volum total del volum i l'rea de la llesca
        int slice=0; //Ens permetr saber a quina llesca ens trobem
	
        while( !inputIt.IsAtEnd() )
	{ 
            //Recorrem tota la llesca (Slice)
            while ( !inputIt.IsAtEndOfSlice() )
            {
                //Mentre no s final de llesca recorrem tota la "lnia"
                while ( !inputIt.IsAtEndOfLine() )
                { 
                    //if(inputIt.Get()==255) 
                    if(inputIt.Get()>0) 
                    {   //Significa que el pxel s ple (hi ha un element i per tant
                        //cal tenir-lo en compte al calcular el volum)
                        totalVolume++;
                        sliceArea++;
                    }
                    ++inputIt;
                }
                inputIt.NextLine();
            }
            //Quan hem acabat de recorrer una llesca guardem el volum calculat dins
            //l'atribut m_area a la posici referent a la llesca
            m_area[slice] = sliceArea;
            sliceArea = 0;
            inputIt.NextSlice();
            slice++;	
	}
	m_totalVolume=totalVolume;
	m_maxSlices = slice;
}


VolumeCalculator::~ VolumeCalculator()
{


}

float VolumeCalculator::getTotalVolume()
{
	return m_totalVolume;
}
  
float VolumeCalculator::getSliceArea(int slice){
	
        if(slice<m_maxSlices)
	{
            return m_area[slice];
	}
        else
        {
            return 0.00;
	}
}