
#ifndef VOLUMECALCULATOR_H
#define VOLUMECALCULATOR_H

#include "itkImage.h"
#include <iostream>
#include "itkImageSliceConstIteratorWithIndex.h"
#include "itkImageLinearIteratorWithIndex.h"
#include "itkImageFileReader.h"
#include "itkImageFileWriter.h"

using namespace itk;

class VolumeCalculator{

private: //posarem la part privada abans de la publica
  
  float           m_totalVolume; //Guardar el volum total del volum
  float           m_area[200];//ho hem fet esttic. Guardar l'rea de cada llesca
  int             m_maxSlices; //Guardara el nmero mxim de llesques

  public:
  typedef signed int PixelType; 
  typedef itk::Image< PixelType, 2 >  ImageType2D;
  typedef itk::Image< PixelType, 3 >  ImageType3D;
  
  typedef itk::ImageLinearIteratorWithIndex< ImageType2D > LinearIteratorType;
  typedef itk::ImageSliceConstIteratorWithIndex< ImageType3D >  SliceIteratorType;

  
  typedef itk::ImageFileReader< ImageType3D > ReaderType;
  typedef itk::ImageFileWriter< ImageType2D > WriterType;

  ImageType3D::Pointer inputImage;
  
  unsigned int projectionDirection;
  unsigned int i, j;
  unsigned int direction[2];
  
  ImageType2D::RegionType region;
  ImageType2D::RegionType::SizeType size;
  ImageType2D::RegionType::IndexType index;
  
  ImageType3D::RegionType requestedRegion;
  
  SliceIteratorType  inputIt;//nose si anir
  
  typedef itk::Image<signed int,3>     ImageType;
  typedef ImageType::Pointer      ImagePointer;

  VolumeCalculator(ImageType* rea, int proj);
  ~VolumeCalculator();
  
  float getTotalVolume();
  float getSliceArea(int slice);
 


  };

#endif
