/***************************************************************************
 *   Copyright (C) 2005 by Grup de Grfics de Girona                       *
 *   http://iiia.udg.es/GGG/index.html?langu=uk                            *
 *                                                                         *
 *   Universitat de Girona                                                 *
 ***************************************************************************/ 
#ifndef UDGVOLUME_CPP
#define UDGVOLUME_CPP

// VTK
#include <vtkImageData.h>

// CPP
#include <iostream.h>

#include "volume.h"

namespace udg {


Volume::Volume()
{
    m_imageDataITK = 0;
    m_imageDataVTK = 0;
    
    m_itkToVtkFilter = ItkToVtkFilterType::New();
    m_vtkToItkFilter = VtkToItkFilterType::New();
}


Volume::~Volume()
{
   
   if( m_imageDataITK.IsNotNull() )
       m_imageDataITK->Delete(); // necessari???
   if( m_imageDataVTK !=0 )
       m_imageDataVTK->Delete();

}

Volume::ItkImageTypePointer Volume::getItkData(  )
{
    return m_imageDataITK; 
}

Volume::VtkImageTypePointer Volume::getVtkData(  )
{
    if( m_imageDataVTK == 0  && m_imageDataITK.IsNotNull() )
    {
        m_itkToVtkFilter->SetInput( m_imageDataITK );
        m_imageDataVTK = m_itkToVtkFilter->GetOutput(); // ficar GetImporter/Exporter?
        try
        {
            m_itkToVtkFilter->Update();
        }
        catch(itk::ExceptionObject & excep)
        {
            std::cerr << "Excepci en el filtre itkToVtk :: Volume::getVtkData " << std::endl;
            std::cerr << excep << std::endl;
          
        }
        //m_itkToVtkFilter->GetImporter()->Update();
    }
    return m_imageDataVTK;
    

}

void Volume::setData( ItkImageTypePointer itkImage  )
{
    m_imageDataITK = itkImage; 
    // \TODO haurem de filtrar a vtk ? o fer nomes en getdata
}

void Volume::setData( VtkImageTypePointer vtkImage )
{
    // \TODO fer cpia local, no noms punter-> com fer-ho?
    m_imageDataVTK = vtkImage;
    
    
    m_vtkToItkFilter->SetInput( m_imageDataVTK );
    m_imageDataITK = m_vtkToItkFilter->GetImporter()->GetOutput();
    
    try
    {
        m_vtkToItkFilter->GetImporter()->Update();
    }
    catch(itk::ExceptionObject & excep)
    {
        std::cerr << "Excepci en el filtre vtkToItk :: Volume::setData " << std::endl;
        std::cerr << excep << std::endl;
        
    }
}


};

#endif
