/***************************************************************************
 *   Copyright (C) 2005 by Grup de Grfics de Girona                       *
 *   http://iiia.udg.es/GGG/index.html?langu=uk                            *
 *                                                                         *
 *   Universitat de Girona                                                 *
 ***************************************************************************/

#ifndef UDGVOLUMEREPOSITORY_CPP
#define UDGVOLUMEREPOSITORY_CPP


#include "volumerepository.h"

#include "volume.h"

#include <iostream.h>

namespace udg {


VolumeRepository::VolumeRepository()
{
}

VolumeRepository::~VolumeRepository()
{
    
    if( m_volume1 )
        delete m_volume1;
    if( m_volume2 )
        delete m_volume2;
}

Identifier VolumeRepository::addVolume( Volume* model)
{
    Identifier id;
    
    if( !m_volume1 )
    {
        m_volume1 = model;
        id = 0;
    }
    else
    {
        if( !m_volume2 )
        {    
            m_volume2 = model;
            id = 1;
        }
    }
    if( id.isNull() )
        std::cerr << "VolRepository::addVolume. No Volume Added. Repository is full"<<std::endl;

    return id;
}



Volume* VolumeRepository::getVolume( Identifier id )
{
    //\TODO Ara es retorna els volums de la segent manera: si id = 0 retornem m_volume1; si id !=0 retornem m_volume2
    //\TODO Cal comprovar que el volum existeixi? Si no existeix, qu es retorna?

    if( id == 0 )
        return m_volume1;
    else
        return m_volume2;
}

void VolumeRepository::removeVolume( Identifier id )
{
    // \TODO T les mateixes restriccions que getVolume: id = 0 == m_volume1; id !=0 == m_volume2. Ara l'nic que far ser alliberar el seu espai de memria

    if( id == 0 )
    {
        if( m_volume1 )
        {
            delete m_volume1;
            m_volume1 = 0;
        }
    }
    else
    {
        if( m_volume2 )
        {
            delete m_volume2;
            m_volume2 = 0;
        }
    }

}

int VolumeRepository::count()
{
    int c = 0;
    // \TODO ara noms far aix peruq noms tenim 2 volums
    if( m_volume1 )
        c++;
    if( m_volume2 )
        c++;
    
    return c;
}


};

#endif

